/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ̧ق͉ƂǗ܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: ATmega32U4
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "conf_usb.h"
#include "audio_task.h"
#include "lib_board/evk_527/evk_527.h"
#include "lib_mcu/usb/usb_drv.h"
#include "lib_mcu/adc/adc_drv.h"
#include "usb_descriptors.h"
#include "modules/usb/device_chap9/usb_standard_request.h"
#include "sound.h"
#include "lib_mcu/timer/timer8_drv.h"
#include "lib_mcu/timer/timer16_drv.h"
#include "lib_mcu/pll/pll_drv.h"
#include "lib_mcu/timer/timerhs_drv.h"

//_____ ϸ ________________________________________________________________

//#define PWM_ENHANCED_MODE

//_____ ` _______________________________________________________________

U16 Get_adc_ext_val (void);

//_____ 錾 _______________________________________________________________

//! g̏
//! ȂTRUEAȂFALSE
//!
bit b_speaker_mute;

//! ǧ݂̉ʂB
S16 s16_speaker_volume;

//! gް͊gg𐧌䂵ĕ␳邽߂ɊɏՕɋLȂ΂Ȃ܂B
#define BUFFER_SIZE		0x400
U8 g_buffer_speaker[BUFFER_SIZE];
U8 *ptr_speaker_data_wr;
U8 *ptr_speaker_data_rd;

//! ϲ̫݂̏
//! ȂTRUEAȂFALSE
//!
bit b_micro_mute;

//! ϲ̫݂݂̌̉ʂB
//! {ł͖
//!
S16 s16_micro_volume;

//! ׯ̎L̍Đʒu
//!
U16 g_u16_micro_sample_pos=0;

#if( SPEAKER_FREQUENCY == 32000 )
  #define TIMER1_MIN_FREQUENCY	251		// (8MHz/1) / 32KHz > 251
  #define TIMER1_MAX_FREQUENCY	249		// (8MHz/1) / 32KHz < 249
#elif( SPEAKER_FREQUENCY == 8000 )
  #define TIMER1_MIN_FREQUENCY	1000	// (8MHz/1) / 8KHz > 999
  #define TIMER1_MAX_FREQUENCY	999		// (8MHz/1) / 8KHz < 1001
#else
  #error SPEAKER_FREQUENCY must be define in config.h
#endif

//! @brief ̊֐USB̊֘Aϐ܂B
//!
void audio_task_init (void)
{
	Joy_init();
	Hwb_button_init();
	init_adc();

	ptr_speaker_data_wr = g_buffer_speaker;
	ptr_speaker_data_rd = g_buffer_speaker;

	//** ϲ̫ݍ\ݒ
	// 8kHzŐM125sɍ̎悳܂B
	Timer8_set_waveform_mode(TIMER8_WGM_CTC_OCR);	// v0 CTC
	Timer8_set_compare(125);						// (1/(8MHz/8))~125125s
	Timer8_set_clock(TIMER8_0_CLKIO_BY_8);			// 8Ou
	Timer8_compare_it_enable();						// r荞݋

	//** g\ݒ
	// vpۯUSBƂɂĊɊJnĂ܂B
	/*
	OSCCAL=0;
	Set_RC_pll_clock();
	Pll_start_auto();
	*/
	// PWMōv평
	Pll_set_hs_tmr_pscal_1dot5();			// PWMg=96/1.5=64MHz
	Timerhs_clear();
	Timerhs_set_waveform_mode(TIMERHS_WGM_FAST_PWM);
	Timerhs_set_nb_bit(10);
	Enable_DAC_pwm();
	Timerhs_set_clock(TIMERHS_CLK_BY_1);
#ifdef PWM_ENHANCED_MODE
	Timerhs_set_enhanced_pwm_mode();
#endif

	// PWMWXVɎgpv1
	Timer16_set_waveform_mode(TIMER16_WGM_CTC_OCR);	// v1 CTC
	Timer16_set_compare_a(TIMER1_MAX_FREQUENCY);
	Timer16_set_clock(TIMER16_CLKIO_BY_1);	// OuȂ
	Timer16_compare_a_it_enable();			// r荞݋

	// 艹
	b_speaker_mute = FALSE;
	b_micro_mute   = FALSE;
	s16_speaker_volume = SPEAKER_VOL_MAX;
	s16_micro_volume   = MICRO_VOL_MAX;
}

//! @brief ǗƂ̓_
//!
void audio_task (void)
{
	if( !Is_device_enumerated() )
		return;								// us

	// OSClex͊gɑ΂Đm32kHz̎gƂA
	// ̂ɎȂA܂ͱް݂ɂȂȂ悤Av͍Đɕ␳܂B
	if( ptr_speaker_data_wr < ptr_speaker_data_rd )
	{
		if( TIMER1_MAX_FREQUENCY == Timer16_get_compare_a() )
		{
			if( (BUFFER_SIZE*1/8)>((U16)ptr_speaker_data_wr+((U16)BUFFER_SIZE-(U16)ptr_speaker_data_rd)) )
			{
				Timer16_set_compare_a(TIMER1_MIN_FREQUENCY);
			}
		}else{
			if( (BUFFER_SIZE*7/8)<((U16)ptr_speaker_data_wr+((U16)BUFFER_SIZE-(U16)ptr_speaker_data_rd)) )
			{
				Timer16_set_compare_a(TIMER1_MAX_FREQUENCY);
			}
		}
	}
	else
	{
		if( TIMER1_MAX_FREQUENCY == Timer16_get_compare_a() )
		{
			if( (BUFFER_SIZE*1/8)>(ptr_speaker_data_wr-ptr_speaker_data_rd) )
			{
				Timer16_set_compare_a(TIMER1_MIN_FREQUENCY);
			}
		}else{
			if( (BUFFER_SIZE*7/8)>(ptr_speaker_data_wr-ptr_speaker_data_rd) )
			{
				Timer16_set_compare_a(TIMER1_MAX_FREQUENCY);
			}
		}
	}

	// ɏՕ𖞂B
	Usb_select_endpoint(EP_AUDIO_OUT);
	if(!Is_usb_receive_out())
		return;
	while (Usb_byte_counter()!=0)
	{
		*ptr_speaker_data_wr++ = Usb_read_byte();
		*ptr_speaker_data_wr++ = Usb_read_byte();
		if( ptr_speaker_data_wr == (g_buffer_speaker+BUFFER_SIZE) )
			ptr_speaker_data_wr = g_buffer_speaker;
	}
	Usb_ack_receive_out();
}

//! @brief v0r荞ݏٰ
//!
//! ADC̎(ϲ̫݂܂͑֊O)𓾂āA𓙎߲ĂɐݒB
//!
//! @note 2dݸ ߲Ă̎gp͒ǉɏՕ̊𓾂邱Ƌ܂B
//!
#ifdef __GNUC__
ISR(TIMER0_COMPA_vect)
#else
#pragma vector = TIMER0_COMPA_vect
__interrupt void timer0_comp_interrupt()
#endif
{
	S16 sample;
	U8 sav_ep;

	if(!Is_device_enumerated())
		return;								// us

	sav_ep=Usb_get_selected_endpoint();		// ۂ߲߂ۑ
	Usb_select_endpoint(EP_AUDIO_IN);
	if(!Is_usb_write_enabled())
	{
		Usb_select_endpoint(sav_ep);		// ߲߂
		return;								// ߲ċ󂫂Ȃ
	}

	if( (b_micro_mute == FALSE)
	 && (s16_micro_volume > 0 ) )
	{
		//** (ϲ̫݁AOAׯ̌{)VK擾
		if( Is_joy_down() )
		{
			// ׯ{Đ
#ifdef __GNUC__
			LSB(sample) = pgm_read_byte_near(&sample_sound[g_u16_micro_sample_pos++]);
			MSB(sample) = pgm_read_byte_near(&sample_sound[g_u16_micro_sample_pos++]);
#else
			LSB(sample) = sample_sound[g_u16_micro_sample_pos++];
			MSB(sample) = sample_sound[g_u16_micro_sample_pos++];
#endif
			if (g_u16_micro_sample_pos > SAMPLE_SOUND_LEN)
				g_u16_micro_sample_pos=0;	// {̏IǍJԂős
		}
		else if( Is_joy_select() || Is_joy_up() )
		{
			// O͎擾
			sample = (S32) (64*Get_adc_ext_val()-0x8000);
		}
		else
		{
			// SĂ̼ޮèJ
			// ϲ̫ݓ͎擾
			sample = (S32) (64*(Get_adc_mic_val()>>(7-(MSB(s16_micro_volume)>>4)))-0x8000);
		}
		// Vo
		Usb_write_byte(LSB(sample));
		Usb_write_byte(MSB(sample));
	}
	else
	{
		//** ǍAVK0o
		Usb_write_byte(0);
		Usb_write_byte(0);
	}

	// ߲߂tȂA𑗏o
	if (Usb_byte_counter()==EP_SIZE_IN)
	{
		Usb_send_in();
	}
	Usb_select_endpoint(sav_ep);			// ߲߂
}

//! @brief ۸ 13擾ٰ (ADC)
//!
//! @note gp҂(EVK527J4.7ŗp\)󂫂PB6͂ɑ݂M̑MIԂƂł܂B
//!		  ͊O킩PB6ɑ鏃Ȑg爽鑪ŝɎgp邱Ƃł܂B
//!
U16 Get_adc_ext_val (void)
{
	Start_conv_channel(0x25);
	while (!Is_adc_conv_finished());
	return (U16)(ADCL+((U16)(ADCH<<8)));
}

//! @brief v1r荞ݏٰ
//!
//! USB߲Ă玎l𓾂āAPWMɐݒ肵܂B
//!
//! @note 2dݸ ߲Ă̎gp͒ǉɏՕ̊𓾂邱Ƌ܂B
//!
#ifdef __GNUC__
ISR(TIMER1_COMPA_vect)
#else
#pragma vector = TIMER1_COMPA_vect
__interrupt void timer1_comp_a_interrupt()
#endif
{
	U16 sample;

	if(!Is_device_enumerated())
	{
		// USBɂPLL֎~̂ŁAG苎邽߂PWMW0ɐݒ
		Timerhs_set_compare_d( 0 );
		return;								// us
	}

	// 䌟
	if( b_speaker_mute )
	{
		Timerhs_set_compare_d( 0x400/4 );
		return;
	}

	// ްǂݍ
	if( ptr_speaker_data_wr == ptr_speaker_data_rd )
		return;								// p\ްȂ
	LSB(sample) = *ptr_speaker_data_rd++;
	MSB(sample) = *ptr_speaker_data_rd++;
	if( ptr_speaker_data_rd == (g_buffer_speaker+BUFFER_SIZE) )
		ptr_speaker_data_rd = g_buffer_speaker;

#ifndef PWM_ENHANCED_MODE
	// ްĎړx:
	// - +0x8000, t16ޯĂ𕄍Ȃ16ޯĂɕϊ邽
	// - >>7, 16ޯĂ9ޯĂɕϊ邽(EVK527̉Zɂ100%WxȂ̂ŁAPWMőS10ޯĂgp܂B)
	// - >>9-(U8)s16_speaker_volume, ʐ2ׂ̂ɂĒl炵܂B
	// PWM։ް𑗂܂B
	Timerhs_set_compare_d( (((U16)sample+0x8000)>>7)>>(9-(U8)s16_speaker_volume) );
#else
	// ްĎړx:
	// - +0x8000, t16ޯĂ𕄍Ȃ16ޯĂɕϊ邽
	// - >>6, 16ޯĂ10ޯĂɕϊ邽(PWM9ޯ+PWMł1ޯ)
	// (EVK527̉Zɂ100%WxȂ̂ŁAPWMőS10ޯĂgp܂B)
	// - >>9-(U8)s16_speaker_volume, ʐ2ׂ̂ɂĒl炵܂B
	// PWM։ް𑗂܂B
	Timerhs_set_compare_d( (((U16)sample+0x8000)>>6)>>(9-(U8)s16_speaker_volume) );
#endif
}
