/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ̧قADCp̒ϸۂƒ`܂݂܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: ATmega32U4
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

#ifndef ADC_DRV_H
#define ADC_DRV_H

//_____ ݸٰ ____________________________________________________________

#ifndef ADHSM
#define ADHSM	7
#endif

//! @defgroup ADC_module ADC
//! ADC
//! @{

//_____ ϸ ________________________________________________________________

#define ADC_ADC1_ADC0_x200			0x0B
#define ADC_ADC1_ADC0_x10			0x09
#define ADC_ADC1_ADC0_x40			0x26
#define ADC_TEMP_SENSOR_CHANNEL		0x27
#define ADC_GND_CHANNEL				0x1F
#define ADC_BG_CHANNEL				0x1E

	//! @defgroup ADC_macros ADCϸ
	//! iADC̎gpϸ
	//! @{

		//! @defgroup Turn_on_adc ADCONɐ؂ւ
		//! ADCONɐ؂ւ
		//! @{
#define Enable_adc()						(ADCSRA |= (1<<ADEN))
		//! @}

		//! @defgroup ADC_alignement_configuration ADC`Ԑݒ
		//! ʐ`Ԑݒ
		//! @{
#define Right_adjust_adc_result()			(ADMUX  &= ~(1<<ADLAR))
#define Left_adjust_adc_result()			(ADMUX  |=  (1<<ADLAR))
		//! @}

		//! @defgroup ADC_high_speed_mode_configuration ADC`Ԑݒ
		//! ADCg200kHzꍇ̍ݒ
		//! @{
#define Enable_adc_high_speed_mode()		(ADCSRB |=  (1<<ADHSM))
#define Disable_adc_high_speed_mode()		(ADCSRB &= ~(1<<ADHSM))
		//! @}

		//! @defgroup ADC_vref_configuration ADCVref`Ԑݒ
		//! Vref`Ԑݒ
		//! @{
#define Enable_internal_vref()				(ADMUX  |=  ((1<<REFS1)|(1<<REFS0)) )
#define Enable_external_vref()				(ADMUX  &= ~((1<<REFS1)|(1<<REFS0)) )
#define Enable_vcc_vref()					(ADMUX  &= ~(1<<REFS1), \
											 ADMUX  |=  (1<<REFS0) )
		//! @}

		//! @defgroup ADC_it_configuration ADC荞݌`Ԑݒ
		//! ADC荞݌`Ԑݒ
		//! @{
#define Enable_all_it()						(SREG   |=  (0x80) )
#define Disable_all_it()					(SREG   &= ~(0x80) )
#define Enable_adc_it()						(ADCSRA |=  (1<<ADIE) )
#define Disable_adc_it()					(ADCSRA &= ~(1<<ADIE) )
#define Clear_adc_flag()					(ADCSRA |=  (1<<ADIF) )
		//! @}

		//! @defgroup ADC_prescaler_configuration ADCOu`Ԑݒ
		//! ADCOu`Ԑݒ
		//! @{
#define Set_adc_prescaler(prescaler)		(ADCSRA &= ~((1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0)),\
											 ADCSRA |=  (prescaler) )
		//! @}

		//! @defgroup ADC_channel_selection ADCّI
		//! ϊׂADCقI
		//! @{
#define MUX4_0_MSK							((1<<MUX4)|(1<<MUX3)|(1<<MUX2)|(1<<MUX1)|(1<<MUX0))
#define Clear_adc_mux()						ADMUX  &= ~(MUX4_0_MSK),(ADCSRB &= ~(1<<MUX5))
#define Select_adc_channel(channel)			(Clear_adc_mux(), ADCSRB |= (channel>>5)<<MUX5, ADMUX |= (channel&MUX4_0_MSK))
		//! @}

		//! @defgroup ADC_start_conversion ADCϊJn
		//! A/DϊJn
		//! @{

			//! @defgroup ADC_start_normal_conversion ADCWϊJn
			//! WŕϊJn
			//! @{
#define Start_conv()						(ADCSRA |= (1<<ADSC) )
#define Start_conv_channel(channel)			(Select_adc_channel(channel), Start_conv() )
			//! @}

			//! @defgroup ADC_start_idle_conversion ADCٕϊJn
			//! GጸA/DϊJn
			//! @{
#define Start_conv_idle()					(SMCR |=  (1<<SM0)|(1<<SE) )
#define Start_conv_idle_channel(channel)	(Select_adc_channel(channel), Start_conv_idle() )
#define Clear_sleep_mode()					(SMCR &= ~(1<<SM0)|(1<<SE) )
			//! @}

		//! @}

		//! @defgroup ADC_get_x_bits_result ADC xޯĂ̌ʎ擾
		//! ADC xޯĂ̌ʎ擾
		//! @{
#define Adc_get_8_bits_result()				((U8)(ADCH))
#define Adc_get_10_bits_result()			((U16)(ADCL+((U16)(ADCH<<8))))
		//! @}

		//! @defgroup Turn_off_adc ADCOFFɐ؂ւ
		//! ADCOFFɐ؂ւ
		//! @{
#define Disable_adc()						(ADCSRA &= ~(1<<ADEN))
		//! @}

		//! @defgroup ϊIꂽۂ
		//! ϊԌ
		//! @{
#define Is_adc_conv_finished()				((ADCSRA &  (1<<ADIF)) ? TRUE : FALSE)
#define Is_adc_conv_not_finished()			((ADCSRA | ~(1<<ADIF)) ? TRUE : FALSE)
		//! @}

	//! @}

//_____ ` _______________________________________________________________

//_____ ֐ _______________________________________________________________

	//! @defgroup ADC_low_level_functions ADCʊ֐
	//! ADCʊ֐
	//! @{

//! ADC``Ԑݒlɏ]ADC`ԐݒBDIDR0DIDR1ڼ޽ɂı۸
//! ͂Ƃĕϊ߰ĂIȂ΂ȂȂƂɒӂĂB
//!
void init_adc (void);
	//! @}

//! @}

#endif // ADC_DRV_H
